Index: cpukit/rtems/src/semmp.c
===================================================================
--- cpukit/rtems/src/semmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/semmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,67 +1,41 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
- *
- * @ingroup RTEMSImplClassicSemaphoreMP
- *
- * @brief This source file contains the implementation to support the Semaphore
- *   Manager in multiprocessing (MP) configurations.
- */
-
 /*
- *  COPYRIGHT (c) 1989-2008.
+ *  Multiprocessing Support for the Semaphore Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
  *  On-Line Applications Research Corporation (OAR).
- *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/semimpl.h>
-#include <rtems/rtems/optionsimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/sysinit.h>
-
-RTEMS_STATIC_ASSERT(
-  sizeof(Semaphore_MP_Packet) <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  Semaphore_MP_Packet
-);
-
-static Semaphore_MP_Packet *_Semaphore_MP_Get_packet( void )
-{
-  return (Semaphore_MP_Packet *) _MPCI_Get_packet();
-}
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/sem.h>
+#include <rtems/thread.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
+ *
+ *  _Semaphore_MP_Send_process_packet
+ *
+ */
 
 void _Semaphore_MP_Send_process_packet (
   Semaphore_MP_Remote_operations  operation,
   Objects_Id                      semaphore_id,
-  rtems_name                      name,
+  Objects_Name                    name,
   Objects_Id                      proxy_id
 )
 {
   Semaphore_MP_Packet *the_packet;
-  uint32_t             node;
+  unsigned32           node;
 
   switch ( operation ) {
@@ -72,5 +46,5 @@
 
       the_packet                    = _Semaphore_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_SEMAPHORE;
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_SEMAPHORE;
       the_packet->Prefix.length     = sizeof ( Semaphore_MP_Packet );
       the_packet->Prefix.to_convert = sizeof ( Semaphore_MP_Packet );
@@ -81,5 +55,5 @@
 
       if ( operation == SEMAPHORE_MP_EXTRACT_PROXY )
-         node = _Objects_Get_node( semaphore_id );
+         node = rtems_get_node( semaphore_id );
       else
          node = MPCI_ALL_NODES;
@@ -96,17 +70,18 @@
 }
 
-static rtems_status_code _Semaphore_MP_Send_request_packet(
+/*PAGE
+ *
+ *  _Semaphore_MP_Send_request_packet
+ *
+ */
+
+rtems_status_code _Semaphore_MP_Send_request_packet (
+  Semaphore_MP_Remote_operations operation,
   Objects_Id                     semaphore_id,
-  rtems_option                   option_set,
-  rtems_interval                 timeout,
-  Semaphore_MP_Remote_operations operation
+  rtems_option                option_set,
+  rtems_interval              timeout
 )
 {
   Semaphore_MP_Packet *the_packet;
-  Status_Control       status;
-
-  if ( !_Semaphore_MP_Is_remote( semaphore_id ) ) {
-    return RTEMS_INVALID_ID;
-  }
 
   switch ( operation ) {
@@ -116,5 +91,5 @@
 
       the_packet                    = _Semaphore_MP_Get_packet();
-      the_packet->Prefix.the_class  = MP_PACKET_SEMAPHORE;
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_SEMAPHORE;
       the_packet->Prefix.length     = sizeof ( Semaphore_MP_Packet );
       the_packet->Prefix.to_convert = sizeof ( Semaphore_MP_Packet );
@@ -126,10 +101,10 @@
       the_packet->option_set        = option_set;
 
-      status = _MPCI_Send_request_packet(
-        _Objects_Get_node( semaphore_id ),
-        &the_packet->Prefix,
-        STATES_WAITING_FOR_SEMAPHORE
-      );
-      return _Status_Get( status );
+      return _MPCI_Send_request_packet(
+          rtems_get_node( semaphore_id ),
+          &the_packet->Prefix,
+          STATES_WAITING_FOR_SEMAPHORE
+        );
+      break;
 
     case SEMAPHORE_MP_ANNOUNCE_CREATE:
@@ -148,29 +123,11 @@
 }
 
-rtems_status_code _Semaphore_MP_Obtain(
-  rtems_id        id,
-  rtems_option    option_set,
-  rtems_interval  timeout
-)
-{
-  return _Semaphore_MP_Send_request_packet(
-    id,
-    option_set,
-    timeout,
-    SEMAPHORE_MP_OBTAIN_REQUEST
-  );
-}
-
-rtems_status_code _Semaphore_MP_Release( rtems_id id )
-{
-  return _Semaphore_MP_Send_request_packet(
-    id,
-    0,
-    MPCI_DEFAULT_TIMEOUT,
-    SEMAPHORE_MP_RELEASE_REQUEST
-  );
-}
-
-static void _Semaphore_MP_Send_response_packet (
+/*PAGE
+ *
+ *  _Semaphore_MP_Send_response_packet
+ *
+ */
+
+void _Semaphore_MP_Send_response_packet (
   Semaphore_MP_Remote_operations  operation,
   Objects_Id                      semaphore_id,
@@ -195,5 +152,5 @@
 
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -210,5 +167,12 @@
 }
 
-static void _Semaphore_MP_Process_packet (
+/*PAGE
+ *
+ *
+ *  _Semaphore_MP_Process_packet
+ *
+ */
+
+void _Semaphore_MP_Process_packet (
   rtems_packet_prefix  *the_packet_prefix
 )
@@ -216,4 +180,5 @@
   Semaphore_MP_Packet *the_packet;
   Thread_Control      *the_thread;
+  boolean              ignored;
 
   the_packet = (Semaphore_MP_Packet *) the_packet_prefix;
@@ -223,10 +188,10 @@
     case SEMAPHORE_MP_ANNOUNCE_CREATE:
 
-      _Objects_MP_Allocate_and_open(
-        &_Semaphore_Information,
-        the_packet->name,
-        the_packet->Prefix.id,
-        true
-      );
+      ignored = _Objects_MP_Open(
+                  &_Semaphore_Information,
+                  the_packet->name,
+                  the_packet->Prefix.id,
+                  TRUE
+                );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -244,7 +209,6 @@
       the_thread = _Thread_MP_Find_proxy( the_packet->proxy_id );
 
-      if ( the_thread != NULL ) {
-        _Thread_queue_Extract( the_thread );
-      }
+      if ( ! _Thread_Is_null( the_thread ) )
+        _Thread_queue_Extract( the_thread->Wait.queue, the_thread );
 
       _MPCI_Return_packet( the_packet_prefix );
@@ -259,5 +223,5 @@
       );
 
-      if ( the_packet->Prefix.return_code != RTEMS_PROXY_BLOCKING )
+      if ( ! _Status_Is_proxy_blocking( the_packet->Prefix.return_code ) )
         _Semaphore_MP_Send_response_packet(
            SEMAPHORE_MP_OBTAIN_RESPONSE,
@@ -290,7 +254,12 @@
 }
 
+/*PAGE
+ *
+ *  _Semaphore_MP_Send_object_was_deleted
+ *
+ */
+
 void _Semaphore_MP_Send_object_was_deleted (
-  Thread_Control *the_proxy,
-  Objects_Id      mp_id
+  Thread_Control *the_proxy
 )
 {
@@ -299,5 +268,5 @@
   _Semaphore_MP_Send_response_packet(
     SEMAPHORE_MP_OBTAIN_RESPONSE,
-    mp_id,
+    the_proxy->Wait.id,
     the_proxy
   );
@@ -305,13 +274,18 @@
 }
 
+/*PAGE
+ *
+ *  _Semaphore_MP_Send_extract_proxy
+ *
+ */
+
 void _Semaphore_MP_Send_extract_proxy (
-  Thread_Control *the_thread,
-  Objects_Id      id
+  Thread_Control *the_thread
 )
 {
   _Semaphore_MP_Send_process_packet(
     SEMAPHORE_MP_EXTRACT_PROXY,
-    id,
-    (rtems_name) 0,
+    the_thread->Wait.id,
+    (Objects_Name) 0,
     the_thread->Object.id
   );
@@ -319,43 +293,14 @@
 }
 
-void  _Semaphore_Core_mutex_mp_support (
-  Thread_Control *the_thread,
-  Objects_Id      id
-)
-{
-  the_thread->receive_packet->return_code = RTEMS_SUCCESSFUL;
-
-  _Semaphore_MP_Send_response_packet(
-     SEMAPHORE_MP_OBTAIN_RESPONSE,
-     id,
-     the_thread
-   );
-}
-
-void  _Semaphore_Core_semaphore_mp_support (
-  Thread_Control *the_thread,
-  Objects_Id      id
-)
-{
-  the_thread->receive_packet->return_code = RTEMS_SUCCESSFUL;
-
-  _Semaphore_MP_Send_response_packet(
-     SEMAPHORE_MP_OBTAIN_RESPONSE,
-     id,
-     the_thread
-   );
-}
-
-static void _Semaphore_MP_Initialize( void )
-{
-  _MPCI_Register_packet_processor(
-    MP_PACKET_SEMAPHORE,
-    _Semaphore_MP_Process_packet
-  );
-}
-
-RTEMS_SYSINIT_ITEM(
-  _Semaphore_MP_Initialize,
-  RTEMS_SYSINIT_CLASSIC_SEMAPHORE_MP,
-  RTEMS_SYSINIT_ORDER_MIDDLE
-);
+/*PAGE
+ *
+ *  _Semaphore_MP_Get_packet
+ *
+ */
+
+Semaphore_MP_Packet *_Semaphore_MP_Get_packet ( void )
+{
+  return ( (Semaphore_MP_Packet *) _MPCI_Get_packet() );
+}
+
+/* end of file */
Index: cpukit/rtems/src/signal.c
===================================================================
--- cpukit/rtems/src/signal.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
+++ cpukit/rtems/src/signal.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -0,0 +1,110 @@
+/*
+ *  Signal Manager
+ *
+ *
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
+ */
+
+#include <rtems/system.h>
+#include <rtems/asr.h>
+#include <rtems/isr.h>
+#include <rtems/modes.h>
+#include <rtems/signal.h>
+#include <rtems/thread.h>
+
+/*PAGE
+ *
+ *  rtems_signal_catch
+ *
+ *  This directive allows a thread to specify what action to take when
+ *  catching signals.
+ *
+ *  Input parameters:
+ *    handler  - address of asynchronous signal routine (asr)
+ *              ( NULL indicates asr is invalid )
+ *    mode_set - mode value for asr
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - always succeeds
+ */
+
+rtems_status_code rtems_signal_catch(
+  rtems_asr_entry   handler,
+  rtems_mode mode_set
+)
+{
+  Thread_Control *executing;
+
+  executing = _Thread_Executing;
+  _Thread_Disable_dispatch(); /* cannot reschedule while */
+                              /*   the thread is inconsistent */
+
+  if ( ! _ASR_Is_null_handler( handler ) ) {
+    executing->Signal.mode_set = mode_set;
+    executing->Signal.handler  = handler;
+  }
+  else
+    _ASR_Initialize( &executing->Signal );
+  _Thread_Enable_dispatch();
+  return( RTEMS_SUCCESSFUL );
+}
+
+/*PAGE
+ *
+ *  rtems_signal_send
+ *
+ *  This directive allows a thread to send signals to a thread.
+ *
+ *  Input parameters:
+ *    id         - thread id
+ *    signal_set - signal set
+ *
+ *  Output parameters:
+ *    RTEMS_SUCCESSFUL - if successful
+ *    error code - if unsuccessful
+ */
+
+rtems_status_code rtems_signal_send(
+  Objects_Id             id,
+  rtems_signal_set signal_set
+)
+{
+  register Thread_Control *the_thread;
+  Objects_Locations        location;
+
+  the_thread = _Thread_Get( id, &location );
+  switch ( location ) {
+    case OBJECTS_ERROR:
+      return( RTEMS_INVALID_ID );
+    case OBJECTS_REMOTE:
+      return _Signal_MP_Send_request_packet(
+        SIGNAL_MP_SEND_REQUEST,
+        id,
+        signal_set
+      );
+    case OBJECTS_LOCAL:
+      if ( ! _ASR_Is_null_handler( the_thread->Signal.handler ) ) {
+        if ( _Modes_Is_asr_disabled( the_thread->current_modes ) )
+          _ASR_Post_signals( signal_set, &the_thread->Signal.signals_pending );
+        else {
+          _ASR_Post_signals( signal_set, &the_thread->Signal.signals_posted );
+          if ( _ISR_Is_in_progress() && _Thread_Is_executing( the_thread ) )
+            _ISR_Signals_to_thread_executing = TRUE;
+        }
+        _Thread_Enable_dispatch();
+        return( RTEMS_SUCCESSFUL );
+      }
+      _Thread_Enable_dispatch();
+      return( RTEMS_NOT_DEFINED );
+  }
+
+  return( RTEMS_INTERNAL_ERROR );   /* unreached - only to remove warnings */
+}
Index: cpukit/rtems/src/signalmp.c
===================================================================
--- cpukit/rtems/src/signalmp.c	(revision 17f744b8c81be98f68d53a82583c9a0b1c690579)
+++ cpukit/rtems/src/signalmp.c	(revision ac7d5ef06a6d6e8d84abbd1f0b82162725f98326)
@@ -1,84 +1,29 @@
-/* SPDX-License-Identifier: BSD-2-Clause */
-
-/**
- * @file
+/*
+ *  Multiprocessing Support for the Signal Manager
  *
- * @ingroup RTEMSImplClassicSignalMP
  *
- * @brief This source file contains the implementation to support the Signal
- *   Manager in multiprocessing (MP) configurations.
+ *  COPYRIGHT (c) 1989, 1990, 1991, 1992, 1993, 1994.
+ *  On-Line Applications Research Corporation (OAR).
+ *  All rights assigned to U.S. Government, 1994.
+ *
+ *  This material may be reproduced by or for the U.S. Government pursuant
+ *  to the copyright license under the clause at DFARS 252.227-7013.  This
+ *  notice must appear in all copies of this file and its derivatives.
+ *
+ *  $Id$
  */
 
-/*
- *  COPYRIGHT (c) 1989-2008.
- *  On-Line Applications Research Corporation (OAR).
+#include <rtems/system.h>
+#include <rtems/mpci.h>
+#include <rtems/mppkt.h>
+#include <rtems/object.h>
+#include <rtems/options.h>
+#include <rtems/signal.h>
+#include <rtems/states.h>
+#include <rtems/thread.h>
+#include <rtems/watchdog.h>
+
+/*PAGE
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- *
- * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
- * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE
- * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
- * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
- * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
- * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
- * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
- * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
- * POSSIBILITY OF SUCH DAMAGE.
- */
-
-#ifdef HAVE_CONFIG_H
-#include "config.h"
-#endif
-
-#include <rtems/rtems/signalimpl.h>
-#include <rtems/rtems/optionsimpl.h>
-#include <rtems/rtems/statusimpl.h>
-#include <rtems/score/statesimpl.h>
-#include <rtems/score/threadimpl.h>
-#include <rtems/score/threadqimpl.h>
-
-/**
- *  The following enumerated type defines the list of
- *  remote signal operations.
- */
-typedef enum {
-  SIGNAL_MP_SEND_REQUEST  = 0,
-  SIGNAL_MP_SEND_RESPONSE = 1
-}   Signal_MP_Remote_operations;
-
-/**
- *  The following data structure defines the packet used to perform
- *  remote signal operations.
- */
-typedef struct {
-  rtems_packet_prefix          Prefix;
-  Signal_MP_Remote_operations  operation;
-  rtems_signal_set             signal_set;
-}   Signal_MP_Packet;
-
-RTEMS_STATIC_ASSERT(
-  sizeof(Signal_MP_Packet) <= MP_PACKET_MINIMUM_PACKET_SIZE,
-  Signal_MP_Packet
-);
-
-static Signal_MP_Packet *_Signal_MP_Get_packet( Objects_Id id )
-{
-  if ( !_Thread_MP_Is_remote( id ) ) {
-    return NULL;
-  }
-
-  return (Signal_MP_Packet *) _MPCI_Get_packet();
-}
-
-/*
  *  _Signal_MP_Send_process_packet
  *
@@ -88,33 +33,55 @@
  */
 
-rtems_status_code _Signal_MP_Send(
-  rtems_id         id,
-  rtems_signal_set signal_set
+/*PAGE
+ *
+ *  _Signal_MP_Send_request_packet
+ *
+ */
+
+rtems_status_code _Signal_MP_Send_request_packet (
+  Signal_MP_Remote_operations operation,
+  Objects_Id                  task_id,
+  rtems_signal_set      signal_in
 )
 {
   Signal_MP_Packet *the_packet;
-  Status_Control    status;
 
-  the_packet = _Signal_MP_Get_packet( id );
-  if ( the_packet == NULL ) {
-    return RTEMS_INVALID_ID;
+  switch ( operation ) {
+
+    case SIGNAL_MP_SEND_REQUEST:
+
+      the_packet                    = _Signal_MP_Get_packet();
+      the_packet->Prefix.the_class  = RTEMS_MP_PACKET_SIGNAL;
+      the_packet->Prefix.length     = sizeof ( Signal_MP_Packet );
+      the_packet->Prefix.to_convert = sizeof ( Signal_MP_Packet );
+      the_packet->operation         = operation;
+      the_packet->Prefix.id         = task_id;
+      the_packet->signal_in         = signal_in;
+
+      return _MPCI_Send_request_packet(
+        rtems_get_node( task_id ),
+        &the_packet->Prefix,
+        STATES_READY   /* Not used */
+      );
+      break;
+
+    case SIGNAL_MP_SEND_RESPONSE:
+      break;
+
   }
-
-  the_packet->Prefix.the_class  = MP_PACKET_SIGNAL;
-  the_packet->Prefix.length     = sizeof( *the_packet );
-  the_packet->Prefix.to_convert = sizeof( *the_packet );
-  the_packet->operation         = SIGNAL_MP_SEND_REQUEST;
-  the_packet->Prefix.id         = id;
-  the_packet->signal_set        = signal_set;
-
-  status = _MPCI_Send_request_packet(
-    _Objects_Get_node( id ),
-    &the_packet->Prefix,
-    STATES_READY
-  );
-  return _Status_Get( status );
+  /*
+   *  The following line is included to satisfy compilers which
+   *  produce warnings when a function does not end with a return.
+   */
+  return RTEMS_INTERNAL_ERROR;
 }
 
-static void _Signal_MP_Send_response_packet (
+/*PAGE
+ *
+ *  _Signal_MP_Send_response_packet
+ *
+ */
+
+void _Signal_MP_Send_response_packet (
   Signal_MP_Remote_operations  operation,
   Thread_Control              *the_thread
@@ -137,5 +104,5 @@
 
       _MPCI_Send_response_packet(
-        _Objects_Get_node( the_packet->Prefix.source_tid ),
+        rtems_get_node( the_packet->Prefix.source_tid ),
         &the_packet->Prefix
       );
@@ -148,4 +115,11 @@
 }
 
+/*PAGE
+ *
+ *
+ *  _Signal_MP_Process_packet
+ *
+ */
+
 void _Signal_MP_Process_packet (
   rtems_packet_prefix  *the_packet_prefix
@@ -153,4 +127,5 @@
 {
   Signal_MP_Packet *the_packet;
+  Thread_Control   *the_thread;
 
   the_packet = (Signal_MP_Packet *) the_packet_prefix;
@@ -162,5 +137,5 @@
       the_packet->Prefix.return_code = rtems_signal_send(
         the_packet->Prefix.id,
-        the_packet->signal_set
+        the_packet->signal_in
       );
 
@@ -173,5 +148,6 @@
     case SIGNAL_MP_SEND_RESPONSE:
 
-      _MPCI_Process_response( the_packet_prefix );
+      the_thread = _MPCI_Process_response( the_packet_prefix );
+
       _MPCI_Return_packet( the_packet_prefix );
       break;
@@ -180,5 +156,6 @@
 }
 
-/*
+/*PAGE
+ *
  *  _Signal_MP_Send_object_was_deleted
  *
@@ -188,5 +165,6 @@
  */
 
-/*
+/*PAGE
+ *
  *  _Signal_MP_Send_extract_proxy
  *
@@ -196,3 +174,14 @@
  */
 
+/*PAGE
+ *
+ *  _Signal_MP_Get_packet
+ *
+ */
+
+Signal_MP_Packet *_Signal_MP_Get_packet ( void )
+{
+  return ( (Signal_MP_Packet *) _MPCI_Get_packet() );
+}
+
 /* end of file */
